(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('@k-adam/ngx-loading-spinner', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/platform-browser'], factory) :
    (global = global || self, factory((global['k-adam'] = global['k-adam'] || {}, global['k-adam']['ngx-loading-spinner'] = {}), global.ng.core, global.rxjs, global.rxjs.operators, global.ng.platformBrowser));
}(this, (function (exports, core, rxjs, operators, platformBrowser) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var SpinnerActionType;
    (function (SpinnerActionType) {
        SpinnerActionType[SpinnerActionType["Show"] = 0] = "Show";
        SpinnerActionType[SpinnerActionType["Hide"] = 1] = "Hide";
        SpinnerActionType[SpinnerActionType["None"] = 2] = "None";
    })(SpinnerActionType || (SpinnerActionType = {}));
    ;
    var SpinnerAction = /** @class */ (function () {
        function SpinnerAction() {
        }
        return SpinnerAction;
    }());
    var NgxLoadingSpinnerService = /** @class */ (function () {
        function NgxLoadingSpinnerService() {
            this.visibleSubject = new rxjs.BehaviorSubject(false);
            this.delayedSubject = new rxjs.Subject();
            this.immediateSubject = new rxjs.Subject();
            this.actionRequested = SpinnerActionType.None;
            this.actionExecuted = SpinnerActionType.None;
            this._timeout = 10000;
            this._threshold = 500;
            this.raceSubject();
        }
        Object.defineProperty(NgxLoadingSpinnerService.prototype, "timeout", {
            set: function (timeout) {
                this._timeout = timeout;
                this.patchShow();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxLoadingSpinnerService.prototype, "threshold", {
            set: function (threshold) {
                this._threshold = threshold;
                this.patchShow();
            },
            enumerable: true,
            configurable: true
        });
        NgxLoadingSpinnerService.prototype.raceSubject = function () {
            var _this = this;
            var delayedSubject = this.delayedSubject.pipe(operators.map(function (t) { return ({ type: t, immediate: false }); }));
            var immediateSubject = this.immediateSubject.pipe(operators.map(function (t) { return ({ type: t, immediate: true }); }));
            var thresholdObserver = rxjs.race(delayedSubject.pipe(operators.debounce(function () { return rxjs.timer(_this._threshold); })), immediateSubject).pipe(operators.take(1), operators.tap(function (action) {
                _this.updatePublicState(action.type);
            }), operators.map(function (action) {
                if (action.type == SpinnerActionType.Show) {
                    return { type: SpinnerActionType.Hide, immediate: false };
                }
                else {
                    return action;
                }
            }));
            var timeoutObserver = rxjs.race(thresholdObserver.pipe(operators.switchMap(function (action) { return (action.immediate ? rxjs.of(action) : rxjs.timer(_this._timeout).pipe(operators.map(function (_) { return action; }))); })), immediateSubject).pipe(operators.take(1));
            timeoutObserver.subscribe(function (action) {
                _this.updatePublicState(action.type);
            }, function (error) { return console.error(error); }, function () { return _this.raceSubject(); });
        };
        NgxLoadingSpinnerService.prototype.show = function () {
            this.actionRequested = SpinnerActionType.Show;
            this.immediateSubject.next(SpinnerActionType.None);
            this.delayedSubject.next(SpinnerActionType.Show);
        };
        NgxLoadingSpinnerService.prototype.hide = function () {
            this.actionRequested = SpinnerActionType.Hide;
            this.immediateSubject.next(SpinnerActionType.Hide);
        };
        //
        NgxLoadingSpinnerService.prototype.patchShow = function () {
            if (this.actionRequested == SpinnerActionType.Show) {
                if (this.actionExecuted == SpinnerActionType.Show) {
                }
                else {
                    this.immediateSubject.next(SpinnerActionType.None);
                    this.delayedSubject.next(SpinnerActionType.Show);
                }
            }
        };
        NgxLoadingSpinnerService.prototype.updatePublicState = function (type) {
            switch (type) {
                case SpinnerActionType.Show:
                    this.actionExecuted = type;
                    this.visibleSubject.next(true);
                    break;
                case SpinnerActionType.Hide:
                    this.actionExecuted = type;
                    this.visibleSubject.next(false);
                    break;
            }
        };
        NgxLoadingSpinnerService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function NgxLoadingSpinnerService_Factory() { return new NgxLoadingSpinnerService(); }, token: NgxLoadingSpinnerService, providedIn: "root" });
        NgxLoadingSpinnerService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], NgxLoadingSpinnerService);
        return NgxLoadingSpinnerService;
    }());

    var NgxLoadingSpinnerComponent = /** @class */ (function () {
        function NgxLoadingSpinnerComponent(service) {
            this.service = service;
            this.zIndex = 100;
            this.visible = false;
        }
        Object.defineProperty(NgxLoadingSpinnerComponent.prototype, "timeout", {
            set: function (v) {
                this.service.timeout = v;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxLoadingSpinnerComponent.prototype, "threshold", {
            set: function (v) {
                this.service.threshold = v;
            },
            enumerable: true,
            configurable: true
        });
        NgxLoadingSpinnerComponent.prototype.ngOnInit = function () {
            this.subscribeToService();
        };
        NgxLoadingSpinnerComponent.prototype.subscribeToService = function () {
            var _this = this;
            this.service.visibleSubject.subscribe(function (spinnerVisible) {
                _this.visible = spinnerVisible;
            });
        };
        NgxLoadingSpinnerComponent.ctorParameters = function () { return [
            { type: NgxLoadingSpinnerService }
        ]; };
        __decorate([
            core.Input()
        ], NgxLoadingSpinnerComponent.prototype, "timeout", null);
        __decorate([
            core.Input()
        ], NgxLoadingSpinnerComponent.prototype, "threshold", null);
        __decorate([
            core.Input()
        ], NgxLoadingSpinnerComponent.prototype, "zIndex", void 0);
        __decorate([
            core.Input()
        ], NgxLoadingSpinnerComponent.prototype, "loadingText", void 0);
        __decorate([
            core.Input()
        ], NgxLoadingSpinnerComponent.prototype, "template", void 0);
        NgxLoadingSpinnerComponent = __decorate([
            core.Component({
                selector: 'ngx-loading-spinner',
                template: "<div class=\"overlay noselect\" [class.on]=\"visible\" [class.off]=\"!visible\" [style.zIndex]=\"zIndex\">\r\n    <div class=\"spinner-container\" *ngIf=\"!template; else showTemplate\">\r\n        <div class=\"spinner-item lds-default\"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>\r\n        <div class=\"spinner-item loading-text\" *ngIf=\"loadingText\">{{ loadingText }}</div>\r\n    </div>\r\n</div>\r\n\r\n<ng-template #showTemplate>\r\n  <div class=\"spinner-container\" [innerHTML]=\"template\"></div>\r\n</ng-template>\r\n",
                styles: [".noselect{-webkit-touch-callout:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.overlay{background-color:rgba(24,24,24,.5);position:fixed;top:0;left:0;width:100%;height:100%;transition:opacity .5s;opacity:0;pointer-events:none}.overlay.on{opacity:1;pointer-events:auto}.spinner-container{color:#fff;font-family:Arial,\"Helvetica Neue\",Helvetica,sans-serif;height:100%;display:flex;flex-direction:column;justify-content:center;align-items:center}.loading-text{text-shadow:0 0 .5rem #202020;font-size:1.5em;text-align:center}.lds-default{display:inline-block;position:relative;width:80px;height:80px}.lds-default div{position:absolute;width:6px;height:6px;background:#fff;border-radius:50%;-webkit-animation:1.2s linear infinite lds-default;animation:1.2s linear infinite lds-default}.lds-default div:nth-child(1){-webkit-animation-delay:0s;animation-delay:0s;top:37px;left:66px}.lds-default div:nth-child(2){-webkit-animation-delay:-.1s;animation-delay:-.1s;top:22px;left:62px}.lds-default div:nth-child(3){-webkit-animation-delay:-.2s;animation-delay:-.2s;top:11px;left:52px}.lds-default div:nth-child(4){-webkit-animation-delay:-.3s;animation-delay:-.3s;top:7px;left:37px}.lds-default div:nth-child(5){-webkit-animation-delay:-.4s;animation-delay:-.4s;top:11px;left:22px}.lds-default div:nth-child(6){-webkit-animation-delay:-.5s;animation-delay:-.5s;top:22px;left:11px}.lds-default div:nth-child(7){-webkit-animation-delay:-.6s;animation-delay:-.6s;top:37px;left:7px}.lds-default div:nth-child(8){-webkit-animation-delay:-.7s;animation-delay:-.7s;top:52px;left:11px}.lds-default div:nth-child(9){-webkit-animation-delay:-.8s;animation-delay:-.8s;top:62px;left:22px}.lds-default div:nth-child(10){-webkit-animation-delay:-.9s;animation-delay:-.9s;top:66px;left:37px}.lds-default div:nth-child(11){-webkit-animation-delay:-1s;animation-delay:-1s;top:62px;left:52px}.lds-default div:nth-child(12){-webkit-animation-delay:-1.1s;animation-delay:-1.1s;top:52px;left:62px}@-webkit-keyframes lds-default{0%,100%,20%,80%{transform:scale(1)}50%{transform:scale(1.5)}}@keyframes lds-default{0%,100%,20%,80%{transform:scale(1)}50%{transform:scale(1.5)}}"]
            })
        ], NgxLoadingSpinnerComponent);
        return NgxLoadingSpinnerComponent;
    }());

    var NgxLoadingSpinnerModule = /** @class */ (function () {
        function NgxLoadingSpinnerModule() {
        }
        NgxLoadingSpinnerModule_1 = NgxLoadingSpinnerModule;
        NgxLoadingSpinnerModule.forRoot = function () {
            return {
                ngModule: NgxLoadingSpinnerModule_1,
                providers: [NgxLoadingSpinnerService]
            };
        };
        var NgxLoadingSpinnerModule_1;
        NgxLoadingSpinnerModule = NgxLoadingSpinnerModule_1 = __decorate([
            core.NgModule({
                declarations: [NgxLoadingSpinnerComponent],
                imports: [
                    platformBrowser.BrowserModule
                ],
                exports: [NgxLoadingSpinnerComponent]
            })
        ], NgxLoadingSpinnerModule);
        return NgxLoadingSpinnerModule;
    }());

    exports.NgxLoadingSpinnerComponent = NgxLoadingSpinnerComponent;
    exports.NgxLoadingSpinnerModule = NgxLoadingSpinnerModule;
    exports.NgxLoadingSpinnerService = NgxLoadingSpinnerService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=k-adam-ngx-loading-spinner.umd.js.map
